<?php 



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

 * DO NOT EDIT THIS FILE DIRECTLY, UNLESS

 * YOU REALLY KNOW WHAT YOU ARE DOING,

 * BECAUSE THE FILE HAS A VARIETY OF EDITING

 * RESTRICTIONS AND COMPLICATED BEHAVIORS.

 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */



if ( ! class_exists('license_code_program'))

{



	class license_code_program {



		public $LC_server			 = '';

		public $product_name		 = '';

		public $unlicensed_message	 = '';

		public $product_id			 = 0;

		public $cookie_expire		 = 0;

		public $keymaster			 = '';

		public $is_theme			 = false;

		private $wp_head_executed	 = false;

		private $website			 = '';

		private $today				 = 0;

		private $license_is_valid	 = false;

		private $messages			 = array();



		function __construct($init = array())

		{

			$this->LC_server			 = $init['LC_server'];

			$this->product_name			 = $init['product_name'];

			$this->unlicensed_message	 = $init['unlicensed_message'];

			$this->product_id			 = (int) (is_numeric($init['product_id']) && $init['product_id'] > 0 ? $init['product_id'] : 0);

			$this->cookie_expire		 = (int) (is_numeric($init['cookie_expire']) && $init['cookie_expire'] > 0 ? $init['cookie_expire'] : 0);

			$this->keymaster			 = $init['keymaster'];

			$this->is_theme				 = 1 == $init['is_theme'] ? true : false;



			/*

			 * Set website here and only here

			 */

			$this->website = $_SERVER["SERVER_NAME"];

			$parts = explode('.',$this->website);

			if($parts[2]){

				$this->website = str_replace($parts[0].".","", $this->website);

			}



			$this->today = mktime(0, 0, 0, date('m'), date('d'), date('Y'));



			add_action('all_admin_notices', array($this, 'check_license'));

		}



		function check_license()

		{

			if ($this->license_is_valid)

				return;



			$this->activate();

		}



		public function run()

		{

			if ($cookie = get_option('license_code_cookie_' . $this->product_id))

			{

				/*

				 * simulate permanent cookies planted until 30 days ago

				 */

				$cookie_expire = $this->cookie_expire <= 30 ? $this->cookie_expire : 0; // 30days max



				if (0 == $cookie_expire)

				{

					/*

					 * 0 = just validate one time. no periodical verification 

					 */

					return $this->license_is_valid = true;

				}



				for ($i = 0; $i <= $cookie_expire; $i ++ )

				{

					$day_ago = mktime(0, 0, 0, date('m'), date('d') - $i, date('Y'));



					$cookie_test = strtoupper(md5($this->keymaster . $day_ago));



					if ($cookie_test == $cookie)

					{

						return $this->license_is_valid = true;

					}

				}

			}



			if ($product_key = get_option('license_code_key_' . $this->product_id))

			{

				if ($this->ask_remote_server($product_key, 'Verification'))

				{

					return $this->license_is_valid = true;

				}

			}



			if ($this->is_theme)

			{

				add_action('wp_head', array($this, 'unlicensed_message_load'));

				add_filter('the_content', array($this, 'unlicensed_message_check'));

				

				/*

				 * if this is a theme don't screw up functions.php!

				 */

				return true;

			}



			/*

			 * we will try activate on check_license()

			 */

			return $this->license_is_valid = false;

		}



		private function ask_remote_server($product_key, $stage)

		{

			$LC_url = $this->LC_server . '/wp-content/plugins/wplicensecode/gateway/verify.php';



			$r = wp_remote_post($LC_url, array(

				'body' => array(

					'website'	 => $this->website,

					'pkey'		 => $product_key,

					'pid'		 => $this->product_id

					)));



			if (is_wp_error($r))

			{

				$this->messages['ask_remote_server'] = 'Problem to access license server. ' . $r->get_error_message();

				return false;

			}



			$content = wp_remote_retrieve_body($r);



			if ('VALID' == $content)

			{

				$this->license_is_valid($product_key);

				return true;

			}



			$this->messages['ask_remote_server'] = "$stage finished with error: $content";

			return false;

		}



		private function license_is_valid($product_key)

		{

			/*

			 * ofbuscate keymaster and today date

			 * simulate cookie

			 */

			$cookie_value = strtoupper(md5($this->keymaster . $this->today));

			update_option('license_code_cookie_' . $this->product_id, $cookie_value);

		}



		private function activate()

		{

			$product_key = '';

			$message	 = '';



			if ($product_key = trim($_POST['license_product_key']))

			{

				if ($this->ask_remote_server($product_key, 'Validation'))

				{

					update_option('license_code_key_' . $this->product_id, $product_key);



					echo <<<EOM

<div class="wrap">

<div id="icon-plugins" class="icon32"><br></div>

<h2>{$this->product_name}</h2>

<div style="width:100%;background-color:#fffbe4;padding: 3px;margin-top:15px;border: solid 1px #dfdfdf"><b>

Activation finished successfully. Thank you.</b></div>

<hr/>

</div>

EOM;

					return;

				}



				if ($this->messages['ask_remote_server'])

				{

					$message = <<<EOM

<div style="width:100%;background-color:#fffbe4;padding: 3px;margin-top:15px;border: solid 1px #dfdfdf"><b>

{$this->messages['ask_remote_server']}

</b></div></p>

EOM;

				}



				$product_key = htmlspecialchars(stripslashes($product_key));

			}



			echo <<<EOM

<div class="wrap">

<div id="icon-plugins" class="icon32"><br></div>

<h2>{$this->product_name}</h2>

$message

<p><div style="background-color:#FFEBE8;border: 1px solid #CC0000;padding:0 5px"><p>

Please enter your product key for this domain:

</p></div></p>

<form method="POST">

<p>

Domain: {$this->website}

</p>

<p>

Product Key: <input type="text" name="license_product_key" value="$product_key" style="width:300px" />

<input type="submit" value="Activate" class="button-primary">

</p>

</form>

<p>Don't have a key? <a href="{$this->LC_server}" target="_blank">Click Here</a></p>

<hr/>

</div>

EOM;

		}



		function unlicensed_message_run()

		{

			$echo = '';

			$echo .= '<div style="padding:5px;width:100%;background-color:red;color:white;text-align:center;font-weight:bold">';

			$echo .= $this->unlicensed_message;

			$echo .= '</div>';



			return $echo;

		}



		function unlicensed_message_load()

		{

			/*

			 * echo through wp_head hook.

			 */

			echo $this->unlicensed_message_run();

			$this->wp_head_executed = true;

		}



		function unlicensed_message_check()

		{

			/*

			 * security:

			 * check if wp_head() was executed in header's theme.

			 */

			if ( ! $this->wp_head_executed)

			{

				return $this->unlicensed_message_run() . $content;

			}

			return $content;

		}



	}



}



?>