<?php

/*

Plugin Name: WP Optins

Plugin URI: http://wpoptins.com

Description: Create Amazing Squeeze Pages with WordPress!

Author: Derrick Van Dyke

Author URI: http://derrickvandyke.com

Version: 3.0.3
*/



############### DO NOT EDIT BELOW THIS LINE #############



require 'updates/plugin-update-checker.php';

$ExampleUpdateChecker = new PluginUpdateChecker(

	'https://s3.amazonaws.com/wpoptinselite/updates.r.json',

	__FILE__,'wp-optins'

);



define( 'WPOPTINS_PLUGIN_NAME','WP Optins');



define( 'WPOPTINS_URL', plugin_dir_url(__FILE__) );

define( 'WPOPTINS_PATH', plugin_dir_path(__FILE__) );

define( 'PREFIX','wpoptins');



include "php/functions.php";





$themeFolder = strstr(get_bloginfo('template_directory'),'wp-content/themes/');

if (!is_writable(ABSPATH.$themeFolder) and $_GET['activate']=='true'){

	add_action('admin_notices', 'wpoptins_not_writable',10,'');

}

function wpoptins_not_writable(){

$themeFolder = strstr(get_bloginfo('template_directory'),'wp-content/themes/');

echo '<div class="error"><p>The theme directory /'.$themeFolder.' is not writable. Set permissions on that folder to CHMOD 777 and re-activate the plugin.</p></div>';

}



function installWPOptins() {

	global $wpdb;



	$templateDir = WPOPTINS_PATH . 'templates';

	$themeFolder = strstr(get_bloginfo('template_directory'),'wp-content/themes/');

	

	if (is_writable(ABSPATH.$themeFolder) AND is_dir($templateDir)){



		$dh  = opendir($templateDir);

		while (false !== ($filename = readdir($dh))) {

			$templateFiles[] = $filename;

		}

		sort($templateFiles);



		unset($templateFiles['0'],$templateFiles['1']);

		foreach ( $templateFiles as $templateFile ) {

			@copy($templateDir . '/' . $templateFile, ABSPATH . $themeFolder . '/' . $templateFile);

		}

		if(file_exists(ABSPATH.$themeFolder.'/wpoptins_page.php'))unlink(ABSPATH.$themeFolder.'/wpoptins_page.php');

		if(file_exists(ABSPATH.$themeFolder.'/wpoptins_squeeze1.php'))unlink(ABSPATH.$themeFolder.'/wpoptins_squeeze1.php');

		if(file_exists(ABSPATH.$themeFolder.'/wpoptins_squeeze2.php'))unlink(ABSPATH.$themeFolder.'/wpoptins_squeeze2.php');



	}

}



function uninstallWPOptins() {

    global $wpdb;

	$themeFolder = strstr(get_bloginfo('template_directory'),'wp-content/themes/');



    //  the id of our page...

    $squeeze_page_id = get_option( 'squeeze_page_id' );

    if( $squeeze_page_id ) {



        wp_delete_post( $squeeze_page_id ); // this will trash, not delete



    }



    delete_option("squeeze_page_title");

    delete_option("squeeze_page_name");

    delete_option("squeeze_page_id");



	if(file_exists(ABSPATH.$themeFolder.'/wpoptins-page.php')) unlink(ABSPATH.$themeFolder.'/wpoptins-page.php');

	if(file_exists(ABSPATH.$themeFolder.'/wpoptins-style.php'))unlink(ABSPATH.$themeFolder.'/wpoptins-style.php');

}



register_deactivation_hook(__FILE__, 'uninstallWPOptins');



register_activation_hook(__FILE__, 'installWPOptins');



if($_GET['action']=='upgrade-plugin' AND preg_match("/wpoptins/i",$_GET['plugin'])){

add_action('wp_loaded','installWPOptins');

}

?>